#!/usr/bin/env python
# Enter your S/N in the format shown under setup/options (123456/012)

from Crypto.Cipher import ARC2
from binascii import hexlify
from builtins import input
import struct

KEY = b"Revision\0"
AVAIL_OPTS = (
        9, 14, 16, 17, 20, 21, 22, 23, 24, 26, 27, 28, 29, 42, 43, 44, 45, 46, 47, 48,
        53, 54, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 83, 84, 85, 86,
        87, 88, 90, 92, 96, 839, 849, 859, 869)

s1,s2 = input("S/N: ").split('/')
s1 = int(s1)
s2 = int(s2)

c = ARC2.new(KEY, mode=1)

for opt in AVAIL_OPTS:
        print("K%3d - %s" % (opt, hexlify(c.encrypt(struct.pack("<II", s1, s2 + (opt << 20)))).decode("utf-8")))
